// Create a mission entry for the server and client RPT file, easier to debug when you know what mission created the error
diag_log text ""; 
diag_log text format["|=============================   %1   =============================|", missionName]; // stamp mission name
diag_log text "";

server execVM "revive_init.sqf";

TitleText ["Clear Feruz Abad", "BLACK FADED", 1]; 
playMusic "Short01_Defcon_Three";

//below are params for MP (learned from Bon's settings and a few other missions)
if (isNil "paramsArray") then {
	paramsArray = [
		12,   // Time of Day
		0,    // weather
		25,   // terrain
		0,    // environment
		2000, // viewdistance
		10    // revive
	];
};

skiptime (((paramsarray select 0) - daytime + 24) % 24);

switch (paramsarray select 1) do {
  case 1: { 0 setOvercast 0; 0 setRain 0; 0 setFog 0 };
  case 2: { 0 setOvercast 1; 0 setRain 1; 0 setFog 0.2 };
  case 3: { 0 setOvercast 0.7; 0 setRain 0; 0 setFog 0 };
  case 4: { 0 setOvercast 0.7; 0 setRain 1; 0 setFog 0.7 };
};

setTerrainGrid (paramsarray select 2);

if ((paramsarray select 3) == 1) then {enableEnvironment true} else {enableEnvironment false};

setViewDistance (paramsarray select 4);

//sets tasks and briefing, and hopefully JiP, not my script... got it out of BAF commandos mission by shark-attack
//really don't understand this one yet or why it works, but it does
[["task4", ["<br/><br/>Get to the <marker name='obj4'>extraction zone</marker>.<br/><br/>", "Extract", "Extract"], getMarkerpos "obj4"], 
["task3", ["<br/><br/>Kill the <marker name='radiusc'>Warlord</marker>.<br/><br/>", "Kill the Warlord", "Kill the Warlord"], getMarkerpos "radiusc"], 
["task2", ["<br/><br/>Destroy the <marker name='radiusb'>scud</marker>.<br/><br/>", "Destroy the scud", "Destroy the scud"],	getMarkerpos "radiusb"],
["task1", ["<br/><br/>Blow up the <marker name='radiusa'>HQ</marker>.<br/><br/>", "Blow up HQ", "Blow up HQ"], getMarkerpos "radiusa"]]
call {
	if (not isdedicated) then {
		waituntil {not isnull player};
		{
			private "_task";
			_task = player createsimpletask [_x select 0];
			_task setsimpletaskdescription (_x select 1);
			_task setsimpletaskdestination (_x select 2);
			_task settaskstate "created";
			missionnamespace setvariable [(_x select 0),_task];
		} foreach _this;
	};
};
[["Credits",["Thanks to BIS for the best games ever.
<br/><br/>Thanks to everyone who has shared their knowledge on the BI Forums... people like W0lle, Kylania, [GLT]Myke, Bon, Celery, [sbs]mac, shk, Tophe, Big Dawg KS, JW Custom, and so many more.<br />
<br/><br/>scripts by - shk, JW Custom, Harpoon1992, Tophe, shark-attack, norrin"]]]
call {
	if (not isdedicated) then {
		private "_credit";
		_credit = _this;
		waituntil {not isnull player};
		for "_i" from ((count _credit) - 1) to 0 step -1 do {
			for [{_k = (count (_credit select _i select 1)) - 1},{_k >= 0},{_k = _k - 1}] do {
				player createDiaryRecord ["Diary", [_credit select _i select 0,_credit select _i select 1 select _k]];
			};
		};
	};
};
[["Technical Details",["Mission  by Mosh
<br/><br/>www.moshland.com
<br/><img image='photo\moshpit.paa' />"]]]
call {
	if (not isdedicated) then {
		private "_tech";
		_tech = _this;
		waituntil {not isnull player};
		for "_i" from ((count _tech) - 1) to 0 step -1 do {
			for [{_k = (count (_tech select _i select 1)) - 1},{_k >= 0},{_k = _k - 1}] do {
				player createDiaryRecord ["Diary", [_tech select _i select 0,_tech select _i select 1 select _k]];
			};
		};
	};
};
[["Hints",["Open up map and Shift Left Click to create waypoint
<br/><br/>Open up map and Left Doubleclick to mark something (up and down arrow keys to change marker)"]]]
call {
	if (not isdedicated) then {
		private "_hints";
		_hints = _this;
		waituntil {not isnull player};
		for "_i" from ((count _hints) - 1) to 0 step -1 do {
			for [{_k = (count (_hints select _i select 1)) - 1},{_k >= 0},{_k = _k - 1}] do {
				player createDiaryRecord ["Diary", [_hints select _i select 0,_hints select _i select 1 select _k]];
			};
		};
	};
};
[["Motor Pool",["You have a couple vehicles, use wisely"]]]
call {
	if (not isdedicated) then {
		private "_motor";
		_motor = _this;
		waituntil {not isnull player};
		for "_i" from ((count _motor) - 1) to 0 step -1 do {
			for [{_k = (count (_motor select _i select 1)) - 1},{_k >= 0},{_k = _k - 1}] do {
				player createDiaryRecord ["Diary", [_motor select _i select 0,_motor select _i select 1 select _k]];
			};
		};
	};
};
[["Intelligence Report",["<img image='photo\warlord.jpg' /> This is the warlord."]]]
call {
	if (not isdedicated) then {
		private "_intel";
		_intel = _this;
		waituntil {not isnull player};
		for "_i" from ((count _intel) - 1) to 0 step -1 do {
			for [{_k = (count (_intel select _i select 1)) - 1},{_k >= 0},{_k = _k - 1}] do {
				player createDiaryRecord ["Diary", [_intel select _i select 0,_intel select _i select 1 select _k]];
			};
		};
	};
};
[["Briefing",["Your orders today are to find the enemy HQ and blow it up, find the scud and destroy it, and find the Warlord rumored to be in the area and eliminate him. Expect heavy resistance."]]]
call {
	if (not isdedicated) then {
		private "_briefing";
		_briefing = _this;
		waituntil {not isnull player};
		for "_i" from ((count _briefing) - 1) to 0 step -1 do {
			for [{_k = (count (_briefing select _i select 1)) - 1},{_k >= 0},{_k = _k - 1}] do {
				player createDiaryRecord ["Diary", [_briefing select _i select 0,_briefing select _i select 1 select _k]];
			};
		};
	};
};

//sets marker text once mission starts
"obj1" setmarkertext "Blow up the HQ";
"obj2" setmarkertext "Destroy the scud";
"obj3" setmarkertext "Kill the Warlord";

//delete editor info markers (init of game logic named delete)
deleteMarker "info1"; deleteMarker "info2"; deleteMarker "info1a"; deleteMarker "info2a";



//forgot why, but sleep for 1 second before continuing
sleep 1;

//starts functions... seems to work best here, is this right?
waitUntil {!(isNil "BIS_MPF_initDone") AND !(isNil "BIS_fnc_init") AND !(isNull player)}; waitUntil {BIS_fnc_init};

//no ai chatting	
{ _x setVariable ["BIS_noCoreConversations", true] } forEach allUnits;

//pmc style gps
["ca\missions_pmc\data\ui_gps_ca.paa",-0.05,0.16] call bis_fnc_customGPS;

//text played 20 seconds after mision start
sleep 20; [str ("Clear Feruz Abad") ,  str(date select 1) + "." + str(date select 2) + "." + str(date select 0), str("Feruz Abad, Takistan")] spawn BIS_fnc_infoText;
